#!/bin/bash
URI="http://127.0.0.1:13025"

out=`curl -s -XGET "$URI/polcard/v1/ingenico_status" -H 'Content-Type: application/json'`
echo "###> status: $out"

if [[ "$out" == *"Idle"* ]]; then
   echo "###> Starting transaction"
   out=`curl -s -XPOST "$URI/polcard/v1/ingenico_prompt_barcode?fulldebug=true" -H 'Content-Type: application/json' -d '{
      "headerText": "Top text",
      "bodyText": "Hello!",
      "time": 3,
      "barcode": "1234567890",
      "transport" : {
         "encryptSession" : false
      }
   }'`
   isOK=`echo $out | jq -r '.ok'`
   if [[ "$isOK" == "true" ]]; then
      echo "###> Barcode started OK"
   else
      echo "###> Error"
      echo $out
      exit;
   fi
fi

COUNTER=0
while [  $COUNTER -lt 150 ]; do
    let COUNTER=COUNTER+1
    out=`curl -s -XGET "$URI/polcard/v1/ingenico_status" -H 'Content-Type: application/json'`
    echo "###> status: $out"
    
    if [[ "$out" == *"AskingEcrToPrintData"* ]]; then
      out=`curl -s -XGET "$URI/polcard/v1/ingenico_display" -H 'Content-Type: application/json'`
      echo "###> displayinfo: $out"
      keyboardOptions=`echo $out | jq -r '.terminal.keyboardOptions'`
      if [[ "$keyboardOptions" == "yes_no" && $COUNTER -gt 5 ]]; then
         echo "###> Sending YES command"
         out=`curl -s -XPOST "$URI/polcard/v1/ingenico_transaction_send_key?fulldebug=true" -H 'Content-Type: application/json' -d '{
            "keycode": "yes"
         }'`
         isOK=`echo $out | jq -r '.ok'`
         echo "###> sendkey: $out"
      fi
    fi
    
    if [[ "$out" == *"WaitPromptEnd"* ]]; then
      break;
    fi
    
    #if [[ "$out" == *"TransactionAborted"* ]]; then
    #  echo "###> Transaction aborted"
    #  break;
    #fi
    
    sleep 1
done

echo "###> Closing prompt"
curl -XGET "$URI/polcard/v1/ingenico_prompt_end?fulldebug=true&resetstate=true" -H 'Content-Type: application/json'

echo "###> Done"
