#!/bin/bash
URI="http://127.0.0.1:3020"

out=`curl -s -XPOST "$URI/v1/tests/log"  -H 'Content-Type: application/json' -d '{ "text" : "#################################################","level" : "info" }'`
out=`curl -s -XPOST "$URI/v1/tests/log"  -H 'Content-Type: application/json' -d '{ "text" : "#          RUNNING TRANSACTION_EXTENDED         #","level" : "info" }'`
out=`curl -s -XPOST "$URI/v1/tests/log"  -H 'Content-Type: application/json' -d '{ "text" : "#################################################","level" : "info" }'`

out=`curl -s -XGET "$URI/polcard/v1/ingenico_status?fulldebug=true" -H 'Content-Type: application/json'`
echo "###> status: $out"
if [[ "$out" == *"WaitTrEnd"* ]]; then
   echo "###> Reading last transaction details before starting new one"
   out=`curl -s -XGET "$URI/polcard/v1/ingenico_transaction_end?fulldebug=true&resetstate=true" -H 'Content-Type: application/json'`
   echo "###> end: $out"
   exit;
fi

if [[ "$out" == *"Idle"* ]]; then
   echo "###> Starting transaction"
   out=`curl -s -XPOST "$URI/polcard/v1/ingenico_transaction?fulldebug=true" -H 'Content-Type: application/json' -d '{
      "type": "purchase",
      "transactionAmount": 2000,
      "cashbackAmount": 0,
      "tipAmount": 0,
      "trackData" : "",
      "surchargeFeeAmount" : 0,
      "foreignGoodsAmount": 0,
      "currencyCode": 985,
      "reversal" : false,
      "transport" : {
         "encryptSession" : false
      },
      "extras": {
         "responseType": "extended_full",
         "date": "2021/04/28 13:23:15",
         "version": "v2.0",
         "manufacturerName": "Big Dot Software",
         "protocolVersion": "0046600"
      }
   }'`
   isOK=`echo $out | jq -r '.ok'`
   if [[ "$isOK" == "true" ]]; then
      echo "###> Transaction started OK"
      echo "###> $out"
   else
      echo "###> Error"
      echo $out
      exit;
   fi
fi

#authorizationCode=`echo $out | jq -r '.terminal.transactionDetails.authorizationCode'`
#echo "###> Transaction closed with '$authorizationCode'"

COUNTER=0
while [  $COUNTER -lt 150 ]; do
    let COUNTER=COUNTER+1
    out=`curl -s -XGET "$URI/polcard/v1/ingenico_status?fulldebug=true" -H 'Content-Type: application/json'`
    echo "###> status: $out"
    
    if [[ "$out" == *"AskingEcrToPrintData"* ]]; then
      out=`curl -s -XGET "$URI/polcard/v1/ingenico_display?fulldebug=true" -H 'Content-Type: application/json'`
      keyboardOptions=`echo $out | jq -r '.terminal.keyboardOptions'`
      echo "###> displayinfo: $out (keyboardOptions: $keyboardOptions)"
      #if [[ "$keyboardOptions" == "yes_no" ]]; then
         #echo "###> Sending YES command"
         #out=`curl -s -XPOST "$URI/polcard/v1/ingenico_transaction_send_key?fulldebug=true" -H 'Content-Type: application/json' -d '{
         #   "keycode": "yes"
         #}'`
         #isOK=`echo $out | jq -r '.ok'`
         #echo "###> sendkey: $out"
      #fi
    fi
    
    if [[ "$out" == *"WaitTrEnd"* ]]; then
      break;
    fi
    
    if [[ "$out" == *"TransactionAborted"* ]]; then
      echo "###> Transaction aborted"
      break;
    fi
    
    sleep 1
done

# Depends on terminal configuration , ingenico_transaction_end may return full information or just the status
echo "###> Closing transaction"
out=`curl -s -XGET "$URI/polcard/v1/ingenico_transaction_end?fulldebug=true" -H 'Content-Type: application/json'`
authorizationResult=`echo $out | jq -r '.terminal.authorizationResult'`
echo $authorizationResult
echo $out

if [[ "$authorizationResult" == "base_approval" || "$authorizationResult" == "base_refusal" ]]; then
   echo "###> Receiving authorizationCode"
   authorizationCode=`echo $out | jq -r '.terminal.transactionDetails.authorizationCode'`
   if [[ "$authorizationCode" == "null" ]]; then
      out=`curl -s -XGET "$URI/polcard/v1/ingenico_transaction_last?fulldebug=true" -H 'Content-Type: application/json'`
      authorizationCode=`echo $out | jq -r '.terminal.transactionDetails.authorizationCode'`
   fi
   echo $out
   echo ""
   echo $authorizationCode
fi
echo "###> Done"
