#!/bin/bash
URI="http://127.0.0.1:3020"

out=`curl -s -XPOST "$URI/v1/tests/log"  -H 'Content-Type: application/json' -d '{ "text" : "#################################################","level" : "info" }'`
out=`curl -s -XPOST "$URI/v1/tests/log"  -H 'Content-Type: application/json' -d '{ "text" : "#               CLOSING BUSINESS DAY            #","level" : "info" }'`
out=`curl -s -XPOST "$URI/v1/tests/log"  -H 'Content-Type: application/json' -d '{ "text" : "#################################################","level" : "info" }'`

out=`curl -s -XGET "$URI/polcard/v1/ingenico_status?fulldebug=true" -H 'Content-Type: application/json'`

if [[ "$out" == *"Idle"* ]]; then
   echo "###> Starting cutoff"
   out=`curl -s -XPOST "$URI/polcard/v1/ingenico_cutoff?fulldebug=true" -H 'Content-Type: application/json' -d '{
      "transport" : {
         "encryptSession" : false
      }
   }'`
   isOK=`echo $out | jq -r '.ok'`
   if [[ "$isOK" == "true" ]]; then
      echo "###> Cutoff started OK"
   else
      echo "###> Error"
      echo $out
      exit;
   fi
else
   echo "Status must be IDLE"
   echo $out
   exit 1
fi

COUNTER=0
while [  $COUNTER -lt 150 ]; do
    let COUNTER=COUNTER+1
    out=`curl -s -XGET "$URI/polcard/v1/ingenico_status?fulldebug=true" -H 'Content-Type: application/json'`
    echo "###> status: $out"
    
    if [[ "$out" == *"WaitCutoffEnd"* ]]; then
      break;
    fi
    
    if [[ "$out" == *"TransactionAborted"* ]]; then
      echo "###> Cutoff aborted"
      break;
    fi
    
    sleep 1
done

echo "###> Fetching cutoff results"
curl -XGET "$URI/polcard/v1/ingenico_cutoff_end?fulldebug=true&resetstate=true" -H 'Content-Type: application/json'

echo "###> Done"
