#!/bin/bash
URI="http://127.0.0.1:3020"

out=`curl -s -XGET "$URI/polcard/v1/ingenico_status?fulldebug=true" -H 'Content-Type: application/json'`
echo "###> status: $out"
if [[ "$out" == *"TransactionAborted"* ]]; then
   echo "###> Clearing current status"
   curl -XGET "$URI/polcard/v1/ingenico_report_end?fulldebug=true&resetstate=true" -H 'Content-Type: application/json'
fi
    
if [[ "$out" == *"Idle"* ]]; then
   echo "###> Starting"
   out=`curl -s -XPOST "$URI/polcard/v1/ingenico_report?fulldebug=true" -H 'Content-Type: application/json' -d '{
     "transport": {
       "encryptSession": false,
       "encryptAlgorithm": "NONE",
       "sessionKeyLen": 0,
       "publicKey": "string"
     },
     "reportType": "batch_report",
     "action": "manual_batch_then_return",
     "profileId": 0,
     "timeout": 30
   }'`
   isOK=`echo $out | jq -r '.ok'`
   if [[ "$isOK" == "true" ]]; then
      echo "###> started OK"
   else
      echo "###> Error"
      echo $out
      exit;
   fi
else
   echo "Terminal status is not Idle"
   exit 1
fi

COUNTER=0
while [  $COUNTER -lt 150 ]; do
    let COUNTER=COUNTER+1
    out=`curl -s -XGET "$URI/polcard/v1/ingenico_status?fulldebug=true" -H 'Content-Type: application/json'`
    echo "###> status: $out"
    
    if [[ "$out" == *"WaitReportEnd"* ]]; then
      break;
    fi
    
    if [[ "$out" == *"TransactionAborted"* ]]; then
      echo "###> Error, interrupted"
      break;
    fi
    
    if [[ "$out" == *"AskingEcrToPrintData"* ]]; then
      out=`curl -s -XGET "$URI/polcard/v1/ingenico_display?fulldebug=true" -H 'Content-Type: application/json'`
      echo "###> displayinfo: $out"
      #keyboardOptions=`echo $out | jq -r '.terminal.keyboardOptions'`
      #if [[ "$keyboardOptions" == "yes_no" ]]; then
         #echo "###> Sending YES command"
         #out=`curl -s -XPOST "$URI/polcard/v1/ingenico_transaction_send_key?fulldebug=true" -H 'Content-Type: application/json' -d '{
         #   "keycode": "yes"
         #}'`
         #isOK=`echo $out | jq -r '.ok'`
         #echo "###> sendkey: $out"
      #fi
    fi 
    
    sleep 1
done

echo "###> Getting report data and reset current state"
curl -XGET "$URI/polcard/v1/ingenico_report_end?fulldebug=true&resetstate=true" -H 'Content-Type: application/json'
      
echo "###> Done"
