#!/bin/bash
URI="http://127.0.0.1:3020"

out=`curl -s -XPOST "$URI/v1/tests/log"  -H 'Content-Type: application/json' -d '{ "text" : "#################################################","level" : "info" }'`
out=`curl -s -XPOST "$URI/v1/tests/log"  -H 'Content-Type: application/json' -d '{ "text" : "#          RUNNING TRANSACTION_SIMPLE           #","level" : "info" }'`
out=`curl -s -XPOST "$URI/v1/tests/log"  -H 'Content-Type: application/json' -d '{ "text" : "#################################################","level" : "info" }'`

out=`curl -s -XGET "$URI/polcard/v1/ingenico_status?fulldebug=true" -H 'Content-Type: application/json'`
echo "###> status: $out"
if [[ "$out" == *"WaitTrEnd"* ]]; then
   echo "###> Reading last transaction details before starting new one"
   out=`curl -s -XGET "$URI/polcard/v1/ingenico_transaction_end?fulldebug=true&resetstate=true" -H 'Content-Type: application/json'`
   echo "###> end: $out"
   exit;
fi

if [[ "$out" == *"Idle"* ]]; then
   echo "###> Starting transaction"
   out=`curl -s -XPOST "$URI/polcard/v1/ingenico_transaction?fulldebug=true" -H 'Content-Type: application/json' -d '{
      "type": "purchase",
      "transactionAmount": 1774,
      "cashbackAmount": 0,
      "tipAmount": 0,
      "trackData" : "",
      "surchargeFeeAmount" : 0,
      "foreignGoodsAmount": 0,
      "currencyCode": 985,
      "reversal" : false,
      "transport" : {
         "encryptSession" : false
      }
   }'`
   isOK=`echo $out | jq -r '.ok'`
   if [[ "$isOK" == "true" ]]; then
      echo "###> Transaction started OK"
   else
      echo "###> Error"
      echo $out
      exit;
   fi
fi

#authorizationCode=`echo $out | jq -r '.terminal.transactionDetails.authorizationCode'`
#echo "###> Transaction closed with '$authorizationCode'"

COUNTER=0
while [  $COUNTER -lt 150 ]; do
    let COUNTER=COUNTER+1
    out=`curl -s -XGET "$URI/polcard/v1/ingenico_status?fulldebug=true" -H 'Content-Type: application/json'`
    echo "###> status: $out"
    
    if [[ "$out" == *"AskingEcrToPrintData"* ]]; then
      out=`curl -s -XGET "$URI/polcard/v1/ingenico_display?fulldebug=true" -H 'Content-Type: application/json'`
      echo "###> displayinfo: $out"
      #exit
      keyboardOptions=`echo $out | jq -r '.terminal.keyboardOptions'`
      #if [[ "$keyboardOptions" == "yes_no" ]]; then
         #echo "###> Sending YES command"
         #out=`curl -s -XPOST "$URI/polcard/v1/ingenico_transaction_send_key?fulldebug=true" -H 'Content-Type: application/json' -d '{
         #   "keycode": "yes"
         #}'`
         #isOK=`echo $out | jq -r '.ok'`
         #echo "###> sendkey: $out"
      #fi
    fi
    
    if [[ "$out" == *"WaitTrEnd"* ]]; then
      break;
    fi
    
    if [[ "$out" == *"TransactionAborted"* ]]; then
      echo "###> Transaction aborted"
      break;
    fi
    
    sleep 1
done

echo "###> Closing transaction"
curl -XGET "$URI/polcard/v1/ingenico_transaction_end?fulldebug=true" -H 'Content-Type: application/json'

echo "###> Done"
