"use strict";const express=require("express"),bodyParser=require("body-parser"),logger=require("./logger"),http=require("http"),https=require("https"),async=require("async"),fs=require("fs"),request=require("request"),path=require("path"),Joi=require("joi"),uuid=require("uuid-random"),os=require("os"),url=require("url"),apipolcard=require("./restapi-polcard"),apitools=require("./restapi-tools"),apiasyncreqs=require("./restapi-asyncreqs"),yaml_config=require("node-yaml-config");logger.logger.info("***************************************** STARTING *****************************************"),logger.logger.info("Loading napi, make sure all DLL files are in place ( ldd build/Release/native.node | grep 'not found' )");const nativeTest=require("./build/Release/native.node");logger.logger.info("napi: DONE"),logger.logger.info("Loading config, make sure config.yml has valid structure");var buildVersion=null,schemaVersion=null,config=yaml_config.load(__dirname+"/config.yml");logger.logger.info("config: DONE");const app=express();app.use(bodyParser.json({limit:"80mb"})),app.use(function(e,o,n){o.header("Access-Control-Allow-Origin","*"),o.header("Access-Control-Allow-Headers","Origin, X-Requested-With, Content-Type, Accept"),n()});var api_definition={"/v1/license/check":{mapto:"/license/v1/check",deprecated:!0},"/license/v1/check":{method:"get",grouptag:"license",func:(e,o)=>{processLicenseCheck(e,o)},description:"Pass ?json=true/false to change the output format",schema_resp:{ok:"bool: true/false",text:"string",validTo:"string",licenseTo:"string",expired:"bool: true/false"}},"/v1/license/upgrade":{mapto:"/license/v1/upgrade",deprecated:!0},"/license/v1/upgrade":{method:"post",grouptag:"license",func:(e,o)=>{processLicenseUpgrade(e,o)},schema_resp:{ok:"bool: true/false",text:"string",validTo:"string",licenseTo:"string",expired:"bool: true/false"}},"/v1/ingenico_status":{mapto:"/eservice/v1/ingenico_status",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_status":{method:"get",grouptag:"eservice",func:(e,o)=>{processIngenicoStatus(e,o)},schema_resp:{ok:"bool: true/false",watermark:"string",error:"string",terminal:{returnCode:"number: (0,1,2,7) - 0 accepted, 1 refused, 2 No connection, 7 interrupted by the user",transactionStatus:"number: (0x00 - 0x81) 0x00 - Idle, 0x01 - WaitCard, 0x02 - WaitPIN, 0x03 - WaitEMVApp, 0x04 - WaitHost, 0x05 - WaitSign, 0x06 - WaitTrEnd, 0x07 - WaitNoCard, 0x08 - WaitBusy, 0x09 - InProgress, 0x0A - WaitCopy, 0x0B - WaitAuthCode, 0x0C - WaitAction, 0x0D - BatchCompleted, 0x0E - DCCCurrency, 0x0F - CashBackAmount, 0x10 - Used internaly, 0x11 - Used internaly, 0x12 - Transaction accepted, 0x13 - Used internaly, 0x14 - Waiting for amount, 0x15 - Waiting for selection, 0x16 - Asking ECR to print data, 0x17 - Presenting ZenCard offer, 0x18 - Waiting for fid, 0x19 - Asking ECR to receive data, 0x20 - Asking ECR to provide data, 0x21 - Zencard continue, 0x80 - Application in error state, 0x81 - Reconciliation needed ",sequenceNb:""}}},"/polcard/v1/ingenico_status":{method:"get",grouptag:"polcard",func:(e,o)=>{apipolcard.processPolcardTransactionStatus(e,o)}},"/polcard/v1/ingenico_statuses":{method:"get",grouptag:"polcard",func:(e,o)=>{apipolcard.processPolcardTransactionStatuses(e,o)}},"/polcard/v1/ingenico_display":{method:"get",grouptag:"polcard",func:(e,o)=>{apipolcard.processPolcardDisplayInfo(e,o)}},"/v1/ingenico_general_info":{mapto:"/eservice/v1/ingenico_general_info",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_general_info":{method:"get",grouptag:"eservice",func:(e,o)=>{processIngenicoGeneralInfo(e,o)},schema_resp:{ok:"bool: true/false",watermark:"string",error:"string",terminal:{returnCode:"number: (0,1,2,7) - 0 accepted, 1 refused, 2 No connection, 7 interrupted by the user",terminalInfo:"string - comma separated data"}}},"/v1/ingenico_auto_transaction_process":{mapto:"/eservice/v1/ingenico_auto_transaction_process",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_auto_transaction_process":{method:"post",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionAuto(e,o)},schema:Joi.object().keys({type:Joi.string().required().valid("purchase","preauthorization","completion","preauthorization_cancel","refund","reversal","giftcard_activation","giftcard_balance","giftcard_topup","reconciliation","connection_test","tms"),amount:Joi.number().required(),title:Joi.string(),sequenceNb:Joi.string(),callback:Joi.object().keys({uri:Joi.string().required(),method:Joi.string().required().valid("POST","GET","PUT")}),posnetserver:Joi.object(),arguments:Joi.object().keys({transactionFlags:Joi.array().items(Joi.string().valid("TokenGeneration","ReferenceNumberGeneration","TransitTransactionIndicator")),blikCode:Joi.number(),additionalPrintout:Joi.string(),hints:Joi.string(),rfu:Joi.string(),variableSymbol:Joi.string(),specificSymbol:Joi.string(),saleItemList:Joi.array().items(Joi.object().keys({itemId:Joi.string(),productCode:Joi.string(),amount:Joi.number(),unitMeasure:Joi.string(),unitPrice:Joi.number(),quantity:Joi.number(),taxCode:Joi.number()}))})}),schema_resp:{ok:"bool: true/false",watermark:"string",error:"string",uuid:"string"},description:'Use posnetserver structure when integration with PosnetServer is enabled (config.posnetserver.active=true). Sample JSON object: {"lines": [{ "na": "Towar 1", "il": 1.0, "vtp": "23,00", "pr": 2350 },{ "na": "Towar 2", "il": 1.0, "vtp": "23,00", "pr": 1150 }], "summary": { "to": 3500 } }. PosnetServer documentation can be found here: https://blog.bigdotsoftware.pl/posnet-server-wydruk-paragonu/'},"/v1/ingenico_auto_transaction_cancel/:uuid":{mapto:"/eservice/v1/ingenico_auto_transaction_cancel/:uuid",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_auto_transaction_cancel/:uuid":{method:"post",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionCancel(e,o)},description:"Method markes request as cancelled and releases COM port. Transaction still have to be manually cancelled from terminal's keyboard",schema_resp:{ok:"bool: true/false",watermark:"string",error:"string",uuid:"string"}},"/v1/ingenico_auto_transaction_status/:uuid":{mapto:"/eservice/v1/ingenico_auto_transaction_status/:uuid",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_auto_transaction_status/:uuid":{method:"get",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionStatus(e,o)},schema_resp:{watermark:"string",ts:"long",state:"string: success, error, cancelled, processing",req:"object",result:"object"}},"/v1/ingenico_auto_transaction_statuses":{mapto:"/eservice/v1/ingenico_auto_transaction_statuses",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_auto_transaction_statuses":{method:"get",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionStatuses(e,o)},schema_resp:{watermark:"string","{uuid}":{ts:"long",state:"string: success, error, cancelled, processing",req:"object",result:"object"}}},"/v1/ingenico_transaction":{mapto:"/eservice/v1/ingenico_transaction",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_transaction":{method:"post",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionStart(e,o)},schema:Joi.object().keys({type:Joi.string().required().valid("purchase","preauthorization","completion","preauthorization_cancel","refund","reversal","giftcard_activation","giftcard_balance","giftcard_topup","reconciliation","connection_test","tms"),amount:Joi.number().required(),title:Joi.string(),sequenceNb:Joi.string().required(),arguments:Joi.object().keys({transactionFlags:Joi.array().items(Joi.string().valid("TokenGeneration","ReferenceNumberGeneration","TransitTransactionIndicator")),blikCode:Joi.number(),additionalPrintout:Joi.string(),hints:Joi.string(),rfu:Joi.string(),variableSymbol:Joi.string(),specificSymbol:Joi.string(),saleItemList:Joi.array().items(Joi.object().keys({itemId:Joi.string(),productCode:Joi.string(),amount:Joi.number(),unitMeasure:Joi.string(),unitPrice:Joi.number(),quantity:Joi.number(),taxCode:Joi.number()}))})}),schema_resp:{ok:"bool: true/false",watermark:"string",error:"string"},description:"sequenceNb is mandatory but for completion and reversal types only. Set it to '-' for other types"},"/polcard/v1/ingenico_transaction":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoTransactionStart(e,o)},schema:apipolcard.ingenicoTransactionSchema(),schema_resp:{ok:"bool: true/false",watermark:"string",error:"string"},description:""},"/v1/ingenico_transaction_last/:transactionIndex":{mapto:"/eservice/v1/ingenico_transaction_last/:transactionIndex",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_transaction_last/:transactionIndex":{method:"get",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionLast(e,o)}},"/v1/ingenico_transaction_end":{mapto:"/eservice/v1/ingenico_transaction_end",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_transaction_end":{method:"get",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionEnd(e,o)},schema_resp:{ok:"bool: true/false",watermark:"string",error:"string",terminal:{returnCode:"number: (0,1,2,7) - 0 accepted, 1 refused, 2 No connection, 7 interrupted by the user",transactionType:"number",transactionResultCode:"number",transactionResultCodeText:"string",transactionNumber:"number",transactionDetails:{authorizationCode:"string",serverMessage:"string",merchantID:"string: example '454500000000000'",maskedCardNumber:"string: example '************0211'",date:"string: example format 2021.01.25",time:"string: example format 12:59:32",cardsetName:"string: example 'VISA'",readerUsed:"string: example 'C' - possible values: B Contactless, M Manual, C Magstripe, P ICC, ? Unknown",readerUsedText:"string: possible values 'magstripe', 'contactless', 'manual', 'icc', 'unknown'",terminalIdentifier:"string: example '45450318'",authorizationMessage:"string: example '000180'",authorizationType:"string: possible values 1 - online, 3 – offline, 4 – referral",authorizationTypeText:"string: possible values 'online', 'offline', 'referral'",transactionAmount:"string",cardholderAuthorizationMethod:"string: possible values A – PIN, @ - Signature, B – PIN and Signature, ? – no authorization",cardholderAuthorizationMethodText:"string: possible values 'pin', 'signature', 'pin_signature', 'no authorization', 'unknown'",atc:"string",ac:"string",aid:"string",tvr:"string",tsi:"string",title:"string",printingIndicator:"string: example '1'",transactionCurrency:"string: example 'PLN'",terminalCurrency:"string",exchangeRate:"string",dcc1:"string",dcc2:"string",cashAmount:"string",spendingAmount:"string",dcc_currencyExp:"string",additionalInformation:"string: example 'DF060A534E204E722056697361DF0B0400000100' or 'DF0B0400000100' or 'DF060A534E204E722056697361DF0B0400000400DF1318343534353033313830303031323630313231323132383534'",additionalInformationObject:"object"},error:"string"}}},"/polcard/v1/ingenico_transaction_end":{method:"get",grouptag:"polcard",func:(e,o)=>{apipolcard.processPolcardIngenicoTransactionEnd(e,o)}},"/polcard/v1/ingenico_transaction_last":{method:"get",grouptag:"polcard",func:(e,o)=>{apipolcard.processPolcardIngenicoTransactionLast(e,o)}},"/polcard/v1/ingenico_transaction_abort":{method:"get",grouptag:"polcard",func:(e,o)=>{apipolcard.processPolcardIngenicoTransactionAbort(e,o)}},"/v1/ingenico_batch_recon_data/:transactionIndex":{mapto:"/eservice/v1/ingenico_batch_recon_data/:transactionIndex",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_batch_recon_data/:transactionIndex":{method:"get",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionReconData(e,o)}},"/v1/ingenico_batch_recon_info":{mapto:"/eservice/v1/ingenico_batch_recon_info",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_batch_recon_info":{method:"get",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionReconInfo(e,o)},schema_resp:{ok:"bool: true/false",watermark:"string",error:"string",terminal:{returnCode:"number: (0,1,2,7) - 0 accepted, 1 refused, 2 No connection, 7 interrupted by the user",error:"string",results:"[] array"}}},"/v1/ingenico_transaction_data_input":{mapto:"/eservice/v1/ingenico_transaction_data_input",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_transaction_data_input":{method:"post",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionDataInput(e,o)},schema:Joi.object().keys({text:Joi.string().required(),sequenceNb:Joi.string().required()}),schema_resp:{ok:"bool: true/false",watermark:"string",error:"string"}},"/polcard/v1/ingenico_transaction_data_input":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoTransactionDataInput(e,o)},schema:Joi.object().keys({text:Joi.string().required(),type:Joi.number().required()})},"/v1/ingenico_transaction_send_key":{mapto:"/eservice/v1/ingenico_transaction_send_key",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_transaction_send_key":{method:"post",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionSendKey(e,o)},schema:Joi.object().keys({keycode:Joi.string().required().valid("ok","back","cancel"),sequenceNb:Joi.string().required()}),schema_resp:{ok:"bool: true/false",watermark:"string",error:"string"}},"/polcard/v1/ingenico_transaction_send_key":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoTransactionSendKey(e,o)},schema:Joi.object().keys({keycode:Joi.string().required().valid("ok","back","cancel","yes","no","anykey")})},"/polcard/v1/ingenico_transaction_send_code":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoTransactionSendCode(e,o)},schema:Joi.object().keys({code:Joi.string().required(),type:Joi.string().required().valid("commercial","authorization")})},"/polcard/v1/ingenico_transaction_send_amount":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoTransactionSendAmount(e,o)},schema:Joi.object().keys({amount:Joi.number().required(),type:Joi.string().required().valid("cashback","other")})},"/polcard/v1/ingenico_transaction_send_option":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoTransactionSendOption(e,o)},schema:Joi.object().keys({option:Joi.number().required()})},"/polcard/v1/ingenico_transaction_send_profile":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoTransactionSendProfile(e,o)},schema:Joi.object().keys({profile:Joi.number().required()})},"/polcard/v1/ingenico_print":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoPrint(e,o)},schema:Joi.object().keys({messageNumber:Joi.number().required(),transport:apipolcard.ingenicoTransportSchema(),printout:Joi.array().required().items(Joi.object().keys({type:Joi.string().required().valid("header","body","footer","date","time","logo"),align:Joi.string().required().valid("left","right","center"),bold:Joi.boolean().default(!1),high:Joi.boolean().default(!1),expand:Joi.boolean().default(!1),text:Joi.string()}))})},"/polcard/v1/ingenico_prompt":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoPrompt(e,o)},schema:Joi.object().keys({transport:apipolcard.ingenicoTransportSchema().required(),type:Joi.string().required().valid("profiles","satisfaction","loyalty_auth","last_upload_status","additional_data_keypad"),reqestParams:Joi.string().allow("")})},"/polcard/v1/ingenico_prompt_barcode":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoPromptBarcode(e,o)},schema:Joi.object().keys({transport:apipolcard.ingenicoTransportSchema().required(),barcode:Joi.string().required(),headerText:Joi.string().required(),bodyText:Joi.string().required(),time:Joi.number().required()})},"/polcard/v1/ingenico_barcode":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoBarcode(e,o)},schema:Joi.object().keys({action:Joi.string().required().valid("scan_one","scan_many","finish")})},"/polcard/v1/ingenico_send_action":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoSetAction(e,o)},schema:Joi.object().keys({transport:apipolcard.ingenicoTransportSchema().required(),action:Joi.string().required().valid("download","restart")})},"/polcard/v1/ingenico_cutoff":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoCutoff(e,o)},schema:Joi.object().keys({transport:apipolcard.ingenicoTransportSchema().required()})},"/polcard/v1/ingenico_cutoff_report":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoCutoffReport(e,o)},schema:Joi.object().keys({transport:apipolcard.ingenicoTransportSchema().required()})},"/polcard/v1/ingenico_cutoff_end":{method:"get",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoCutoffEnd(e,o)}},"/polcard/v1/ingenico_report":{method:"post",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoReport(e,o)},schema:Joi.object().keys({transport:apipolcard.ingenicoTransportSchema().required(),reportType:Joi.string().required().valid("batch_report","cumulative_report"),action:Joi.string().required().valid("batch_return","manual_batch_then_return","cumulative_return","cumulative_return_reset_counters"),profileId:Joi.number().required().min(0).max(99),timeout:Joi.number().required()})},"/polcard/v1/ingenico_report_end":{method:"get",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoReportEnd(e,o)}},"/polcard/v1/ingenico_prompt_end":{method:"get",grouptag:"polcard",func:(e,o)=>{apipolcard.processIngenicoPromptEnd(e,o)}},"/v1/ingenico_set_parameter":{mapto:"/eservice/v1/ingenico_set_parameter",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_set_parameter":{method:"post",grouptag:"eservice",func:(e,o)=>{processIngenicoTerminalSetParameter(e,o)},schema:Joi.object().keys({type:Joi.string().required().valid("volatile","permanent"),parameters:Joi.array().required().items(Joi.object().keys({key:Joi.string().required(),value:Joi.string().required()}))})},"/v1/ingenico_set_standby":{mapto:"/eservice/v1/ingenico_set_standby",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_set_standby":{method:"post",grouptag:"eservice",func:(e,o)=>{processIngenicoTerminalSetStandby(e,o)},schema:Joi.object().keys({timeoutSeconds:Joi.number().required()})},"/v1/ingenico_report_generate":{mapto:"/eservice/v1/ingenico_report_generate",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_report_generate":{method:"post",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionReportGenerate(e,o)}},"/v1/ingenico_report_details/:cardset":{mapto:"/eservice/v1/ingenico_report_details/:cardset",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_report_details/:cardset":{method:"get",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionGetSummary(e,o)}},"/v1/ingenico_report_summary":{mapto:"/eservice/v1/ingenico_report_summary",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_report_summary":{method:"get",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionGetTotalSummary(e,o)}},"/v1/ingenico_analysis_generate":{mapto:"/eservice/v1/ingenico_analysis_generate",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_analysis_generate":{method:"post",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionAnalysisGenerate(e,o)}},"/v1/ingenico_analysis_details/:transactionIndex":{mapto:"/eservice/v1/ingenico_analysis_details/:transactionIndex",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_analysis_details/:transactionIndex":{method:"get",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionAnalysisDetails(e,o)}},"/v1/ingenico_analysis_summary":{mapto:"/eservice/v1/ingenico_analysis_summary",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_analysis_summary":{method:"get",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionAnalysisTotalSummary(e,o)}},"/v1/ingenico_dcc_analysis_generate":{mapto:"/eservice/v1/ingenico_dcc_analysis_generate",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_dcc_analysis_generate":{method:"post",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionDCCAnalysisGenerate(e,o)}},"/v1/ingenico_dcc_analysis_details/:transactionIndex":{mapto:"/eservice/v1/ingenico_dcc_analysis_details/:transactionIndex",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_dcc_analysis_details/:transactionIndex":{method:"get",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionDCCAnalysisDetails(e,o)}},"/v1/ingenico_dcc_analysis_summary":{mapto:"/eservice/v1/ingenico_dcc_analysis_summary",grouptag:"eservice",deprecated:!0},"/eservice/v1/ingenico_dcc_analysis_summary":{method:"get",grouptag:"eservice",func:(e,o)=>{processIngenicoTransactionDCCAnalysisTotalSummary(e,o)}},"/":{method:"get",func:(e,o)=>{processRootRestApi(e,o)}}};function convertToSampleJSON(e){var o={};return null!=e.$_terms.keys&&e.$_terms.keys.forEach(e=>{if("object"==e.schema.type){var n=JSON.stringify(convertToSampleJSON(e.schema));o[e.key]=n}else if(o[e.key]=e.schema.type,null!=e.schema._valids&&null!=e.schema._valids._values){o[e.key]+=": ";const n=[...e.schema._valids._values];o[e.key]+=n.join(", ")}}),o}function getProtocol(e){var o=e.connection.encrypted?"https":"http";return(o=e.headers["x-forwarded-proto"]||o).split(/\s*,\s*/)[0]}function initOtherOptions(e){buildVersion=e.buildVersion,schemaVersion=e.schemaVersion}function getCashRegisterNumber(e){return null==e?1:null==e.query?1:null==e.query.cashRegisterNumber?1:isNaN(e.query.cashRegisterNumber)?1:e.query.cashRegisterNumber}function isResetFlagEnabled(e){return null!=e&&(null!=e.query&&(null!=e.query.reset&&("false"!=e.query.reset&&"true"==e.query.reset)))}function initApiDefinitions(e){for(const[o,n]of Object.entries(e)){const r=null!=n.mapto?e[n.mapto]:n;"get"==r.method?app.get(o,r.func):"put"==r.method?app.put(o,r.func):"post"==r.method?app.post(o,r.func):"delete"==r.method?app.delete(o,r.func):logger.logger.error("Unrecognized method: "+r.method)}}function initHiddenApiDefinitions(){app.get("/v1/tests/run",(e,o)=>{processRunTests(e,o)}),app.post("/v1/tests/log",(e,o)=>{processLogExtra(e,o)})}function processRootRestApi(e,o){var n=[{groupname:"General information"},{type:"GET",name:""},{groupname:"License"}];for(const[e,o]of Object.entries(api_definition))"license"==o.grouptag&&n.push({type:o.method.toUpperCase(),name:e.substr(1),deprecated:!1});n.push({groupname:"IngenicoServer methods (eService)"});for(const[e,o]of Object.entries(api_definition))"/"!=e&&0==e.startsWith("/auto_queue")&&"eservice"==o.grouptag&&(null==o.mapto?n.push({type:o.method.toUpperCase(),name:e.substr(1),deprecated:!1}):n.push({type:api_definition[o.mapto].method.toUpperCase(),name:e.substr(1),deprecated:o.deprecated}));n.push({groupname:"IngenicoServer methods (Polcard - First Data)"});for(const[e,o]of Object.entries(api_definition))"/"!=e&&0==e.startsWith("/auto_queue")&&"polcard"==o.grouptag&&(null==o.mapto?n.push({type:o.method.toUpperCase(),name:e.substr(1),deprecated:!1}):n.push({type:api_definition[o.mapto].method.toUpperCase(),name:e.substr(1),deprecated:o.deprecated}));var r="";n.forEach(o=>{o.deprecated||(null!=o.groupname?r+="<br>\n<b>"+o.groupname+"</b><br>\n":null!=o.ref?(r+=api_definition[o.ref].method.toUpperCase().padEnd(6," ").replace(/ /g,"&nbsp;")+" "+getProtocol(e)+"://"+e.headers.host+"/"+o.ref.substr(1)+"  <br>\n",null!=api_definition[o.ref].attributes&&api_definition[o.ref].attributes.length>0&&api_definition[o.ref].attributes.forEach(e=>{r+="       ".replace(/ /g,"&nbsp;")+" ?"+e.attribute+" = "+e.description+" (default: "+e.default+")  <br>\n"})):(r+=o.type.padEnd(6," ").replace(/ /g,"&nbsp;")+" "+getProtocol(e)+"://"+e.headers.host+"/"+o.name+"  <br>\n",o.schema&&(r+="Request:<br>\n"+apitools.prettyJson(convertToSampleJSON(o.schema)).replace(/\t/g,"<br>")+"  <br>\n"),o.schema_resp&&(r+="Response:<br>\n"+apitools.prettyJson(o.schema_resp).replace(/\t/g,"<br>")+"  <br>\n"),o.description&&(r+="Description:<br>\n"+o.description+"  <br>\n"),(o.schema||o.schema_resp)&&(r+="  <hr>\n")))}),r+="<br>\n<b>Deprecated methods (compatible with 1.3)</b><br>\n",n.forEach(o=>{o.deprecated&&(r+=o.type.padEnd(6," ").replace(/ /g,"&nbsp;")+" "+getProtocol(e)+"://"+e.headers.host+"/"+o.name+"  <br>\n")}),o.send("<tt>\nIngenico Server v."+buildVersion+" (schema "+schemaVersion+') © 2021 BigDotSoftware (bigdotsoftware@bigdotsoftware.pl). <br>\nHow to start: https://blog.bigdotsoftware.pl/ingenico-server-pierwsze-uzycie/ <br>\n<br>\nSwagger YAML: &nbsp; <a href="https://github.com/bigdotsoftware/ingenicoserver/blob/main/swagger/swagger-'+schemaVersion+'.yaml">https://github.com/bigdotsoftware/ingenicoserver/blob/main/swagger/swagger-'+buildVersion+'.yaml</a> <br>\n<br>\nSwagger Editor: <a href="https://editor.swagger.io/?url=https://download2.bigdotsoftware.pl/github_ingenico_swagger/swagger-'+schemaVersion+'.yaml">Open in Editor</a> <br>\n<br>\nRESTful API: <br></tt><tt>\n'+r+"</tt>")}function replaceAll(e,o,n){return e.split(o).join(n)}function processLicenseUpgrade(e,o){setTimeout(function(){if(null==config.license.file||""==config.license.file)return apitools.sendErrorResponse(e,o,"Wersja nielicencjonowana");logger.logger.info("license file: "+config.license.file);var n=nativeTest.ValidateLicenseFile({file:config.license.file});if(logger.logger.info(JSON.stringify(n)),null!=n.results){var r="";if(n.results.forEach(e=>{null!=e.uniqueLicenseId&&""!=e.uniqueLicenseId&&(r=e.uniqueLicenseId)}),""!=r?apitools.obtainNewLicenseFile(r):logger.logger.error("Cannot determine unique license ID"),n.ok){var t=apitools.readStatInfo(n);return apitools.sendResponse(e,o,{ok:!0,text:"Wersja licencjonowana dla "+t.licenseTo+" wazna do "+new Date(1e3*t.validTo).toISOString(),validTo:t.validTo,licenseTo:t.licenseTo,expired:t.expired,requested:!0,requestedtext:"Requested for new license file. Check logs for more details"})}return apitools.sendErrorResponse(e,o,"Wersja nielicencjonowana")}},500)}function processLicenseCheck(e,o){setTimeout(function(){var n=apitools.CheckLicense();if(n.ok){var r=apitools.readStatInfo(n);return e.query.json?apitools.sendResponse(e,o,{ok:!0,text:"Wersja licencjonowana dla "+r.licenseTo+" wazna do "+new Date(1e3*r.validTo).toISOString(),validTo:r.validTo,licenseTo:r.licenseTo,expired:r.expired}):apitools.sendResponse(e,o,"Wersja licencjonowana dla "+r.licenseTo+" wazna do "+new Date(1e3*r.validTo).toISOString())}return e.query.json?apitools.sendErrorResponse(e,o,{ok:!1,text:"Wersja nielicencjonowana",expired:!0}):apitools.sendErrorResponse(e,o,"Wersja nielicencjonowana")},500)}function processRunTests(e,o){var n=apitools.isFullDebugMode(e);const r=nativeTest.RunTests(n?"1":"0");return apitools.sendResponse(e,o,r)}function processLogExtra(e,o){var n=Joi.object().keys({text:Joi.string().required(),level:Joi.string().required().valid("info","error","debug","warn")}).validate(e.body);if(null!=n.error)return logger.logger.error("Payload validation error:"+JSON.stringify(n)),apitools.sendErrorResponse(e,o,n.error);switch(e.body.level){case"info":logger.logger.info(e.body.text);break;case"error":logger.logger.error(e.body.text);break;case"debug":logger.logger.debug(e.body.text);break;case"warn":logger.logger.warn(e.body.text)}return o.json({})}function processIngenicoStatus(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.ConnectionBegin(e,t=>{if(!t.ok)return void apitools.sendErrorResponse(e,o,t);const i=nativeTest.GetTermInfo(n?"1":"0",{cashRegisterNumber:r});var s=apitools.ConnectionEnd();return s.ok?apitools.sendResponse(e,o,i):apitools.sendErrorResponse(e,o,s)})}function processIngenicoGeneralInfo(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.ConnectionBegin(e,t=>{if(!t.ok)return void apitools.sendErrorResponse(e,o,t);const i=nativeTest.GetTermGeneralInfo(n?"1":"0",{cashRegisterNumber:r});var s=apitools.ConnectionEnd();return s.ok?apitools.sendResponse(e,o,i):apitools.sendErrorResponse(e,o,s)})}function verifyTermResponse(e,o,n,r){if(0!=n.terminal.returnCode){null!=o&&apitools.sendErrorResponse(e,o,n);apitools.ConnectionEnd();return null!=r&&setRequestError(r,n.error,n),!1}return!0}function processIngenicoTransactionReconData(e,o){var n=apitools.isFullDebugMode(e);const r=e.params.transactionIndex;var t=getCashRegisterNumber(e);apitools.ConnectionBegin(e,i=>{if(!i.ok)return void apitools.sendErrorResponse(e,o,i);const s=nativeTest.TransactionReconData(n?"1":"0",{transactionIndex:r,cashRegisterNumber:t});if(verifyTermResponse(e,o,s)){var a=apitools.ConnectionEnd();return a.ok?apitools.sendResponse(e,o,s):apitools.sendErrorResponse(e,o,a)}})}function processIngenicoTransactionLast(e,o){var n=apitools.isFullDebugMode(e);const r=e.params.transactionIndex;var t=getCashRegisterNumber(e);apitools.ConnectionBegin(e,i=>{if(!i.ok)return void apitools.sendErrorResponse(e,o,i);const s=nativeTest.TransactionLastData(n?"1":"0",{transactionIndex:r,cashRegisterNumber:t});if(verifyTermResponse(e,o,s)){var a=apitools.ConnectionEnd();return a.ok?apitools.sendResponse(e,o,s):apitools.sendErrorResponse(e,o,a)}})}function processIngenicoTransactionReconInfo(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.ConnectionBegin(e,t=>{if(!t.ok)return void apitools.sendErrorResponse(e,o,t);const i=nativeTest.TransactionReconInfo(n?"1":"0",{cashRegisterNumber:r});if(verifyTermResponse(e,o,i)){var s=apitools.ConnectionEnd();return s.ok?apitools.sendResponse(e,o,i):apitools.sendErrorResponse(e,o,s)}})}function processIngenicoTransactionDataInput(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.validateSchema(e,o,api_definition)&&apitools.ConnectionBegin(e,t=>{if(!t.ok)return void apitools.sendErrorResponse(e,o,t);const i=nativeTest.TransactionDataInput(n?"1":"0",{text:e.body.text,sequenceNb:e.body.sequenceNb,cashRegisterNumber:r});if(verifyTermResponse(e,o,i)){var s=apitools.ConnectionEnd();return s.ok?apitools.sendResponse(e,o,i):apitools.sendErrorResponse(e,o,s)}})}function processIngenicoTransactionSendKey(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.validateSchema(e,o,api_definition)&&apitools.ConnectionBegin(e,t=>{if(!t.ok)return void apitools.sendErrorResponse(e,o,t);var i="";"ok"==e.body.keycode?i="\\n":"back"==e.body.keycode?i="\\b":"cancel"==e.body.keycode&&(i="\\e");const s=nativeTest.TransactionDataInput(n?"1":"0",{text:i,sequenceNb:e.body.sequenceNb,cashRegisterNumber:r});if(verifyTermResponse(e,o,s)){var a=apitools.ConnectionEnd();return a.ok?apitools.sendResponse(e,o,s):apitools.sendErrorResponse(e,o,a)}})}function processIngenicoTerminalSetParameter(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.validateSchema(e,o,api_definition)&&apitools.ConnectionBegin(e,t=>{if(!t.ok)return void apitools.sendErrorResponse(e,o,t);const i=nativeTest.TerminalSetParameter(n?"1":"0",{parameters:e.body.parameters,typeOfParameter:"permanent"==e.body.type?1:0,cashRegisterNumber:r});if(verifyTermResponse(e,o,i)){var s=apitools.ConnectionEnd();return s.ok?apitools.sendResponse(e,o,i):apitools.sendErrorResponse(e,o,s)}})}function processIngenicoTerminalSetStandby(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.validateSchema(e,o,api_definition)&&apitools.ConnectionBegin(e,t=>{if(!t.ok)return void apitools.sendErrorResponse(e,o,t);const i=nativeTest.TerminalSetStandby(n?"1":"0",{timeoutSeconds:e.body.timeoutSeconds,cashRegisterNumber:r});if(verifyTermResponse(e,o,i)){var s=apitools.ConnectionEnd();return s.ok?apitools.sendResponse(e,o,i):apitools.sendErrorResponse(e,o,s)}})}function processIngenicoTransactionReportGenerate(e,o){var n=apitools.isFullDebugMode(e),r=isResetFlagEnabled(e),t=getCashRegisterNumber(e);apitools.ConnectionBegin(e,i=>{if(!i.ok)return void apitools.sendErrorResponse(e,o,i);const s=nativeTest.TransactionReportGenerate(n?"1":"0",{reset:r?"1":"0",cashRegisterNumber:t});if(verifyTermResponse(e,o,s)){var a=apitools.ConnectionEnd();return a.ok?apitools.sendResponse(e,o,s):apitools.sendErrorResponse(e,o,a)}})}function processIngenicoTransactionGetSummary(e,o){var n=apitools.isFullDebugMode(e);const r=e.params.cardset;var t=getCashRegisterNumber(e);apitools.ConnectionBegin(e,i=>{if(!i.ok)return void apitools.sendErrorResponse(e,o,i);const s=nativeTest.TransactionReportGetSummary(n?"1":"0",{cardset:r,cashRegisterNumber:t});if(verifyTermResponse(e,o,s)){var a=apitools.ConnectionEnd();return a.ok?apitools.sendResponse(e,o,s):apitools.sendErrorResponse(e,o,a)}})}function processIngenicoTransactionGetTotalSummary(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.ConnectionBegin(e,t=>{if(!t.ok)return void apitools.sendErrorResponse(e,o,t);const i=nativeTest.TransactionReportGetTotalSummary(n?"1":"0",{cashRegisterNumber:r});if(verifyTermResponse(e,o,i)){var s=apitools.ConnectionEnd();return s.ok?apitools.sendResponse(e,o,i):apitools.sendErrorResponse(e,o,s)}})}function processIngenicoTransactionAnalysisGenerate(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.ConnectionBegin(e,t=>{if(!t.ok)return void apitools.sendErrorResponse(e,o,t);const i=nativeTest.TransactionAnalysisGenerate(n?"1":"0",{cashRegisterNumber:r});if(verifyTermResponse(e,o,i)){var s=apitools.ConnectionEnd();return s.ok?apitools.sendResponse(e,o,i):apitools.sendErrorResponse(e,o,s)}})}function processIngenicoTransactionAnalysisDetails(e,o){var n=apitools.isFullDebugMode(e);const r=e.params.transactionIndex;var t=getCashRegisterNumber(e);apitools.ConnectionBegin(e,i=>{if(!i.ok)return void apitools.sendErrorResponse(e,o,i);const s=nativeTest.TransactionAnalysisGetDetails(n?"1":"0",{transactionIndex:r,cashRegisterNumber:t});if(verifyTermResponse(e,o,s)){var a=apitools.ConnectionEnd();return a.ok?apitools.sendResponse(e,o,s):apitools.sendErrorResponse(e,o,a)}})}function processIngenicoTransactionAnalysisTotalSummary(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.ConnectionBegin(e,t=>{if(!t.ok)return void apitools.sendErrorResponse(e,o,t);const i=nativeTest.TransactionAnalysisGetTotalSummary(n?"1":"0",{cashRegisterNumber:r});if(verifyTermResponse(e,o,i)){var s=apitools.ConnectionEnd();return s.ok?apitools.sendResponse(e,o,i):apitools.sendErrorResponse(e,o,s)}})}function processIngenicoTransactionDCCAnalysisGenerate(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.ConnectionBegin(e,t=>{if(!t.ok)return void apitools.sendErrorResponse(e,o,t);const i=nativeTest.TransactionDCCAnalysisGenerate(n?"1":"0",{cashRegisterNumber:r});if(verifyTermResponse(e,o,i)){var s=apitools.ConnectionEnd();return s.ok?apitools.sendResponse(e,o,i):apitools.sendErrorResponse(e,o,s)}})}function processIngenicoTransactionDCCAnalysisDetails(e,o){var n=apitools.isFullDebugMode(e);const r=e.params.transactionIndex;var t=getCashRegisterNumber(e);apitools.ConnectionBegin(e,i=>{if(!i.ok)return void apitools.sendErrorResponse(e,o,i);const s=nativeTest.TransactionDCCAnalysisGetDetails(n?"1":"0",{transactionIndex:r,cashRegisterNumber:t});if(verifyTermResponse(e,o,s)){var a=apitools.ConnectionEnd();return a.ok?apitools.sendResponse(e,o,s):apitools.sendErrorResponse(e,o,a)}})}function processIngenicoTransactionDCCAnalysisTotalSummary(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.ConnectionBegin(e,t=>{if(!t.ok)return void apitools.sendErrorResponse(e,o,t);const i=nativeTest.TransactionDCCAnalysisGetTotalSummary(n?"1":"0",{cashRegisterNumber:r});if(verifyTermResponse(e,o,i)){var s=apitools.ConnectionEnd();return s.ok?apitools.sendResponse(e,o,i):apitools.sendErrorResponse(e,o,s)}})}function ClearBatchCompleted(e,o,n){for(var r=getCashRegisterNumber(e),t=0;t<100;t++){if(!verifyTermResponse(e,o,nativeTest.TransactionReconInfo(n?"1":"0",{cashRegisterNumber:r})))return!1;var i=nativeTest.GetTermInfo(n?"1":"0",{cashRegisterNumber:r});if(!verifyTermResponse(e,o,i))return!1;if(0==i.terminal.transactionStatus)break}return!0}function processIngenicoTransactionEnd(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.ConnectionBegin(e,t=>{if(t.ok){var i=nativeTest.TransactionEnd(n?"1":"0",{cashRegisterNumber:r});if(verifyTermResponse(e,o,i)){logger.logger.info("trEnd done: "+JSON.stringify(i));var s=apitools.ConnectionEnd();return s.ok?apitools.sendResponse(e,o,i):apitools.sendErrorResponse(e,o,s)}}else apitools.sendErrorResponse(e,o,t)})}function sleep(e){return new Promise(o=>{setTimeout(o,e)})}function processIngenicoTransactionCancel(e,o){var n=e.params.uuid;return null!=apiasyncreqs.getCurrentRequests()[n]?(logger.logger.info(`Marking request ${n} cancelled`),setRequestCancelled(n,{ok:!1}),apitools.sendResponse(e,o,apiasyncreqs.getCurrentRequests()[n])):apitools.sendErrorResponse(e,o,"Wrong UUID")}function processIngenicoTransactionStatus(e,o){return null!=apiasyncreqs.getCurrentRequests()[e.params.uuid]?apitools.sendResponse(e,o,apiasyncreqs.getCurrentRequests()[e.params.uuid]):apitools.sendErrorResponse(e,o,"Wrong UUID")}function processIngenicoTransactionStatuses(e,o){return apitools.sendResponse(e,o,apiasyncreqs.getCurrentRequests())}function processIngenicoTransactionAuto(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.validateSchema(e,o,api_definition)&&apitools.ConnectionBegin(e,async t=>{if(!t.ok)return void apitools.sendErrorResponse(e,o,t);const i=uuid();setRequestProcessing(i,e.body);var s=nativeTest.GetTermInfo(n?"1":"0",{cashRegisterNumber:r});if(!verifyTermResponse(e,o,s,i))return;if(logger.logger.info("trStatus done: "+JSON.stringify(s)),129==s.terminal.transactionStatus){const t=nativeTest.TransactionBegin(n?"1":"0",{type:"reconciliation",amount:0,title:"",sequenceNb:"",arguments:{},cashRegisterNumber:r,file:apitools.GetLicenseFile()});if(logger.logger.info("trReconciliation done: "+JSON.stringify(t)),!verifyTermResponse(e,o,t,i))return;s=await startListeningForWaitTrEnd(e,o,n,i);var a=nativeTest.TransactionEnd(n?"1":"0",{cashRegisterNumber:r});if(!verifyTermResponse(e,o,a,i))return;if(logger.logger.info("trEnd done: "+JSON.stringify(a)),s=nativeTest.GetTermInfo(n?"1":"0",{cashRegisterNumber:r}),!verifyTermResponse(e,o,s,i))return;logger.logger.info("trStatus done: "+JSON.stringify(s))}if(13==s.terminal.transactionStatus&&!ClearBatchCompleted(e,o,n))return void apitools.ConnectionEnd();if(1==s.terminal.transactionStatus)return logger.logger.warn("Cannot interrupt transaction in WAIT_CARD state"),apitools.ConnectionEnd(),void apitools.sendErrorResponse(e,o,{ok:!1,error:s.terminal.transactionStatusText+" : Przyłuż kartę lub anuluj na terminalu rozpoczętą transakcję"});if(6==s.terminal.transactionStatus){logger.logger.info("Interrupting current transaction in WAIT_TREND state");a=nativeTest.TransactionEnd(n?"1":"0",{cashRegisterNumber:r});if(!verifyTermResponse(e,o,a,i))return;if(logger.logger.info("trEnd done: "+JSON.stringify(a)),s=nativeTest.GetTermInfo(n?"1":"0",{cashRegisterNumber:r}),!verifyTermResponse(e,o,s,i))return;logger.logger.info("trStatus done: "+JSON.stringify(s))}const c=nativeTest.TransactionBegin(n?"1":"0",{type:e.body.type,amount:null!=e.body.amount?e.body.amount:0,title:null!=e.body.title?e.body.title:"",sequenceNb:null!=e.body.sequenceNb?e.body.sequenceNb:"",arguments:null!=e.body.arguments?e.body.arguments:{},cashRegisterNumber:r,file:apitools.GetLicenseFile()});if(logger.logger.info("trBegin done: "+JSON.stringify(c)),verifyTermResponse(e,o,c,i)){if(c.ok?apitools.sendResponse(e,o,{ok:!0,uuid:i}):apitools.sendErrorResponse(e,o,c),6!=(s=await startListeningForWaitTrEnd(e,null,n,i)).terminal.transactionStatus)return logger.logger.info("Interrupting due to wrong status: "+JSON.stringify(s)),void apitools.ConnectionEnd();a=nativeTest.TransactionEnd(n?"1":"0",{cashRegisterNumber:r});if(verifyTermResponse(e,null,a,i)){logger.logger.info("trEnd done: "+JSON.stringify(a)),0==a.terminal.transactionResultCode?setRequestSuccess(i,a):1==a.terminal.transactionResultCode||7==a.terminal.transactionResultCode?setRequestCancelled(i,a):setRequestError(i,"",a),e.body.callback&&apitools.notifyBackendAboutTransactionResult(a,e.body.callback),config.posnetserver.active&&(e.body.posnetserver?0==a.terminal.transactionResultCode?apitools.sendToPosnetServer(e.body.posnetserver):logger.logger.warn("Integracja z PosnetServer jest włączona, transakcja na terminalu nie zakonczyla sie sukcesem - paragon nie bedzie drukowany"):logger.logger.warn("Integracja z PosnetServer jest włączona, ale request nie zawiera struktury 'posnetserver' którą można przekazać do serwisu."));var p=apitools.ConnectionEnd();p.ok||logger.logger.error("cannot end: "+JSON.stringify(p))}}})}async function startListeningForWaitTrEnd(e,o,n,r){var t=getCashRegisterNumber(e),i=nativeTest.GetTermInfo(n?"1":"0",{cashRegisterNumber:t});if(updateCurrentResponseObj(r,i),!verifyTermResponse(e,o,i))return i;for(logger.logger.info("trStatus done: "+JSON.stringify(i));6!=i.terminal.transactionStatus;){if(i=nativeTest.GetTermInfo(n?"1":"0",{cashRegisterNumber:t}),updateCurrentResponseObj(r,i),!verifyTermResponse(e,o,i))return i;if(logger.logger.info("trStatus done: "+JSON.stringify(i)),null!=apiasyncreqs.getCurrentRequests()[r]&&"cancelled"==apiasyncreqs.getCurrentRequests()[r].state)return logger.logger.info(`Received cancelled flag for ${r}`),i;await sleep(1e3)}return i}function processIngenicoTransactionStart(e,o){var n=apitools.isFullDebugMode(e),r=getCashRegisterNumber(e);apitools.validateSchema(e,o,api_definition)&&apitools.ConnectionBegin(e,t=>{if(!t.ok)return void apitools.sendErrorResponse(e,o,t);var i=nativeTest.GetTermInfo(n?"1":"0",{cashRegisterNumber:r});if(!verifyTermResponse(e,o,i))return;if((logger.logger.info("trStatus done: "+JSON.stringify(i)),13==i.terminal.transactionStatus)&&!ClearBatchCompleted(e,o,n))return void apitools.ConnectionEnd();if(1==i.terminal.transactionStatus)return apitools.ConnectionEnd(),void apitools.sendErrorResponse(e,o,{ok:!1,error:i.terminal.transactionStatusText+" : Przyłuż kartę lub zamknij rozpoczętą transakcję"});if(6==i.terminal.transactionStatus)return apitools.ConnectionEnd(),void apitools.sendErrorResponse(e,o,{ok:!1,error:i.terminal.transactionStatusText+" : Zamknij niedokończoną transakcję"});logger.logger.info("TransactionBegin - preparing");const s=nativeTest.TransactionBegin(n?"1":"0",{type:e.body.type,amount:null!=e.body.amount?e.body.amount:0,title:null!=e.body.title?e.body.title:"",sequenceNb:null!=e.body.sequenceNb?e.body.sequenceNb:"",arguments:null!=e.body.arguments?e.body.arguments:{},cashRegisterNumber:r,file:apitools.GetLicenseFile()});if(logger.logger.info("trBegin done: "+JSON.stringify(s)),verifyTermResponse(e,o,s)){var a=apitools.ConnectionEnd();return a.ok?apitools.sendResponse(e,o,{ok:!0}):apitools.sendErrorResponse(e,o,a)}})}function initNative(){var e=null!=config.ingenico.commanddelay?config.ingenico.commanddelay:200,o=null!=config.ingenico.waitdelay?config.ingenico.waitdelay:100,n=null!=config.ingenico.commandresponsetimeout?config.ingenico.commandresponsetimeout:1e4,r=null!=config.ingenico.responsewaitdelay?config.ingenico.responsewaitdelay:100;logger.logger.info("Initializing ingenico module"),nativeTest.InitializeModule({loggernative:config.logger.native,licensefile:apitools.GetLicenseFile(),commanddelay:e,waitdelay:o,responsewaitdelay:r,commandresponsetimeout:n})}function initScheduleQueueCleaner(){logger.logger.info(`Scheduling queue cleaner with retention of ${config.queue.retention} ms`),setInterval(function(){const e=config.queue.retention;apiasyncreqs.cleanOlderThan(e)},2e3)}function initPinger(){if(config.ingenico.ping.active){var e=config.ingenico.ping.cashRegisterNumber;null==e&&(e=1),logger.logger.info(`Scheduling pinger with interval ${config.ingenico.ping.interval} ms on cashRegisterNumber=${e}`),setInterval(function(){apitools.ConnectionBegin(null,o=>{if(!o.ok)return void logger.logger.error("PING|Port open error: "+JSON.stringify(o));const n=nativeTest.GetTermInfo("0",{cashRegisterNumber:e});var r=null!=n.terminal.transactionStatusText?n.terminal.transactionStatusText:"";logger.logger.info(`PING|status: ${n.terminal.transactionStatus} with text: '${r}'`);var t=apitools.ConnectionEnd();t.ok||logger.logger.error("PING|Port close error: "+JSON.stringify(t))})},config.ingenico.ping.interval)}else logger.logger.info("Pinger is disabled in configuration. To enable it set ingenico.ping.active=true")}function initLicense(){return logger.logger.info(`Checking license file ${apitools.GetLicenseFile()} .....`),apitools.CheckLicense()}function init(e,o,n){initApiDefinitions(api_definition),initHiddenApiDefinitions(),initOtherOptions(n),initScheduleQueueCleaner(),console.log(" _                         _                ______                                "),console.log("| |                       (_)              / _____)                               "),console.log("| |____   ____ _____ ____  _  ____ ___    ( (____  _____  ____ _   _ _____  ____  "),console.log("| |  _ \\ / _  | ___ |  _ \\| |/ ___) _ \\    \\____ \\| ___ |/ ___) | | | ___ |/ ___) "),console.log("| | | | ( (_| | ____| | | | ( (__| |_| |   _____) ) ____| |    \\ V /| ____| |     "),console.log("|_|_| |_|\\___ |_____)_| |_|_|\\____)___/   (______/|_____)_|     \\_/ |_____)_|     "),console.log("        (_____|                                                                   "),logger.logger.info(`Trying to open HTTP on port: ${e.port}`);try{var r=http.createServer(app);r.on("error",function(o){logger.logger.error(`Cannot (1) start HTTP at http://localhost:${e.port}, please check if there no another process listening on the same port. Reason: ${o}`)}),r.listen(e.port),logger.logger.info("HTTP  at http://localhost:"+e.port)}catch(o){logger.logger.error(`Cannot start HTTP at http://localhost:'${e.port}, please check if there no another process listening on the same port. Reason: ${o}`)}if(o.active){logger.logger.info(`Loading SSL certs...: ${o.sslcertificates.key}`);var t=null;try{t={key:fs.readFileSync(o.sslcertificates.key),cert:fs.readFileSync(o.sslcertificates.crt)}}catch(e){logger.logger.error(`Cannot load certificates ${o.sslcertificates.key} and ${o.sslcertificates.crt}. Reason: ${e}`)}if(null!=t){logger.logger.info(`Trying to open HTTPS on port: ${o.port}`);try{https.createServer(t,app).listen(o.port),logger.logger.info(`HTTPS at https://localhost: ${o.port}`)}catch(e){logger.logger.error(`Cannot start HTTPS at https://localhost: ${o.port}, please check your certificate under the ./cert directory. Reason: ${e}`)}}}else logger.logger.info("HTTPS is disabled in configuration. To enable set https.active=true in config.yml");initNative(),initDrivers(),initPinger(),initLicense()}function initDrivers(){apipolcard.initModule(nativeTest,api_definition),apitools.initModule(nativeTest)}module.exports.init=init;